package server;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;

public class ServerB {

	public static void main(String[] args) throws IOException {
		System.out.println("Starting Server...");
		
		//Öffne eine Verbindungsstelle für eingehende Verbindungen
		ServerSocket serverSocket = new ServerSocket(9998);
		System.out.println("Waiting for clients...");
		
		//Solange isAcceptingNewClients true ist tue:
		boolean isAcceptingNewClients = true;
		while(isAcceptingNewClients) {
			//Warte bis sich ein client verbindet.
			Socket clientSocket = serverSocket.accept();
			System.out.println("Client connected from: " + clientSocket.getInetAddress().getHostAddress());
			
			//Starte einen Thread, mit der Aufgabe solange den input des Verbundenen clienten zu lesen,
			//Bis dieser die Verbindung beendet.
			ServerReaderTask task = new ServerReaderTask(clientSocket);
			Thread clientHandlerThread = new Thread(task);
			clientHandlerThread.start();
		}
		
		
		//Schliesse die Verbindungsstelle für eingehende Verbindungen
		serverSocket.close();
		System.out.println("Server shut down.");
	}
	
	private static class ServerReaderTask implements Runnable {
		
		private Socket socket;
		
		public ServerReaderTask(Socket socket) {
			this.socket = socket;
		}
		
		@Override
		public void run() {
			try {
				//Initialisiere einen 'Leser', der aus dem Input liest, der von dem clienten kommt.
				BufferedReader reader = new BufferedReader(new InputStreamReader(socket.getInputStream()));
				//Initialisiere einen 'Schreiber', der aus in den output schreibt der zum clienten führt
				PrintWriter writer = new PrintWriter(socket.getOutputStream());
				
				//So lange wie die Verbindung besteht (Sonst wird die gelesene Zeile null sein) tue:
				String line;
				while((line = reader.readLine()) != null) {
					//Erstelle einen neuen 'Antwort' String aus dem Input vom clienten
					String answer = line.toUpperCase();
					//Sende die Antwort zurück an den clienten.
					writer.println(answer);
					writer.flush();
				}
			} catch (IOException e) { }
			
			//Sobald die Zeile null ist, wissen wir die Verbindung wurde unterbrochen.
			//In diesem fall bricht die Schleife ab und die Methode run läuft zu ende. 
			System.out.println("Client at " + socket.getInetAddress().getHostAddress() + " disconnected.");
		}
		
	}
	
}
